/********************************************************

         IMA ADPCM audio decoder
	 Copyright 2000 Eugene Smith (divx@euro.ru)
	 Last modified: 23.06.2000

*********************************************************/

#include <stdio.h>
#include <iostream.h>
#include "adpcm.h"
int ADPCM_Decoder::Init(WAVEFORMATEX* wf, void* extension)
{
    state.valprev=0;
    state.index=0;
    if(wf)
    {
	format=*wf;
	return 0;
    }
    else return -1;	
}
#warning TEST WITH MONO
int ADPCM_Decoder::Convert(unsigned char* in_data, unsigned in_size,
	    unsigned char* out_data, unsigned out_size,
	    unsigned* size_read, unsigned* size_written)
{
    if(in_data==0)return -1;
    if(out_data==0)return -1;
    if(format.nChannels==1)
    {
	int nsamples=in_size/512;
	if(nsamples>out_size/2036)nsamples=out_size/2036;
	for(int i=0; i<nsamples; i++)
	{
	    int* inp=(int*)(in_data+i*512+4);
	    short* dest=(short*)(out_data+i*2036);
	    state.valprev=inp[-1];
	    state.index=inp[-1]>>16;
	    dest[0]=state.valprev;
	    adpcm_decoder((char*)inp, dest+1, 1016, &state);
	}    
        if(size_read)*size_read=nsamples*512;
	if(size_written)*size_written=nsamples*2036;
	return 0;
    }
    else
    {
	int in_left[128], in_right[128];
	short out_left[1016], out_right[1016];
	int nsamples=in_size/1024;
	if(nsamples>out_size/4072)nsamples=out_size/4072;
	for(int i=0; i<nsamples; i++)
	{
	    int* inp=(int*)(in_data+i*1024+8);
	    for(int j=0; j<127; j++)
	    {
		in_left[j]=inp[2*j];
		in_right[j]=inp[2*j+1];
	    }	
	    short* dest=(short*)(out_data+i*4072);
	    state.valprev=inp[-2];
	    state.index=inp[-2]>>16;
	    dest[0]=state.valprev;
	    adpcm_decoder((char*)in_left, out_left, 1016, &state);
	    state.valprev=inp[-1];
	    state.index=inp[-1]>>16;
            dest[1]=state.valprev;
	    adpcm_decoder((char*)in_right, out_right, 1016, &state);
	    for(int j=0; j<1016; j++)
	    {
		dest[2+2*j]=out_left[j];
		dest[2+2*j+1]=out_right[j];
	    }	
	}    
    	if(size_read)*size_read=nsamples*1024;
	if(size_written)*size_written=nsamples*4072;
	return 0;
    }    	
}