/********************************************************

	AVI player
	Copyright 2000 Eugene Smith (divx@euro.ru)
	Last modified: 28.07.2000

*********************************************************/


#include <qapp.h>
#include <signal.h>
#include <iostream.h>
#include <unistd.h>
#ifdef __FreeBSD__
#include <floatingpoint.h>
#endif
#include "mywidget.h"
#include <default.h>
MyWidget *m;
extern void killer(int);
extern int quit_flag, stop_flag, open_flag, play_flag, pause_flag, reseek_flag;
extern int nextpage_flag, prevpage_flag;
extern int GetPhysicalDepth(QPaintDevice* dev);

int main(int argc, char **argv)
{
#ifdef __FreeBSD__
    fpsetmask(fpgetmask() & ~(FP_X_DZ|FP_X_INV));
#endif
    
    if(GetAvifileVersion()!=AVIFILE_VERSION)
    {
	cout<<"This binary was compiled for Avifile ver. "<<AVIFILE_VERSION<<", but the library is ver. "<<GetAvifileVersion()<<". Aborting."<<endl;
	return 0;
    }	


    QApplication a(argc,argv);

    int result;
    char* fn;
    m=new MyWidget(384,60);
    int zoom=1;
        
    if(argc==2)
	if(strcmp(argv[1], "--help")==0)
	{
	    cout<<"Usage: aviplay [-zoom] [<avi-file> [<subtitle-file>]] "<<endl;
	    cout<<"               -zoom  Enables zooming of all movies to 50% size"<<endl;
	    cout<<"                      ( for slow machines ). Only for 16 and 32"<<endl;
	    cout<<"                      bits, 24-bit modes are unsupported."<<endl;
	    return -1;
	}    
    if(argc>=2)
	if(strcmp(argv[1], "-zoom")==0)
	{
	    if(GetPhysicalDepth(m)==24)
	    {
		cout<<"Sorry, no zooming for 24 bit modes"<<endl;
		return -1;
	    }	
	    argv++;
	    argc--;
	    zoom=2;
	}    
    try
    {
	if(argc>=2)
        {
    	    fn=argv[1];
	    const char* subname=NULL;
	    if(argc>2) subname=argv[2];
	    m->initPlayer(fn, zoom, subname);
	}
	else m->open_slot();
    }
    catch(FatalError& error)
    {
	if(argc>=2)
	    error.Print();
    }	    
    signal(SIGINT, killer);
    m->show();
    a.setMainWidget(m);
    while(m)
    {
	if(stop_flag)
	{
	    cout<<"stop_func()"<<endl;
	    stop_flag=0;
	    m->stop_func();
	}
	if(open_flag)
	{
	    cout<<"Open_func()"<<endl;
	    open_flag=0;
	    m->open_func();
	}			
	if(pause_flag)
	{    
	    cout<<"pause_func()"<<endl;
	    pause_flag=0;
	    m->pause_func();
	}			
	if(play_flag)
	{
	    cout<<"play_func()"<<endl;
    	    play_flag=0;
    	    m->play_func();
        }			
        if(reseek_flag)
        {
	    cout<<"reseek_func()"<<endl;
	    reseek_flag=0;
	    m->reseek_func();
	}	
	if(nextpage_flag)
	{
	    cout<<"nextpage()"<<endl;
	    nextpage_flag=0;
	    m->nextpage_func();
	}    
	if(prevpage_flag)
	{
	    cout<<"prevpage()"<<endl;
	    prevpage_flag=0;
	    m->prevpage_func();
	}    
	if(quit_flag)
	{
	    cout<<"Quitting..."<<endl;
	    m->endPlayer();
	    delete m;
	    m=0;
	    return 0;
	}    
	if(m->isPlaying())
	    usleep(100000);
	else    
	    qApp->processEvents(100);
    }	
    return 0;
}
