/********************************************************

	Main AVI player widget
	Copyright 2000 Eugene Smith (divx@euro.ru)
	Last modified: 27.07.2000

*********************************************************/

#define Debug
#define Sync
#define DEBUG_TOCONSOLE


#include <stdio.h>
#include <iostream>

#include <qwidget.h>
#include <qfiledialog.h>
#include <qapp.h>
#include <qpainter.h>
#include <qobject.h>
#include <qtimer.h>
#include <qpushbutton.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <iostream.h>
#include <assert.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <qmessagebox.h>

#include "renderer.h"
#include "mywidget.h"

VideoRenderer *renderer;

using namespace std;



extern MyWidget* m;

QString open_qs;

/******************************************

This stuff is used to redirect user actions
from actual event processing function to
starting thread ( main() ). Why just not
to process events in main()? Hm, I dunno.
Try and see what happens ;-)

******************************************/

int quit_flag=0;
int stop_flag=0;
int open_flag=0;
int play_flag=0;
int pause_flag=0;
int reseek_flag=0;
int nextpage_flag=0;
int prevpage_flag=0;
void MyWidget::open_slot()
{
    open_qs=QFileDialog::getOpenFileName();
    if(!open_qs.isNull())
	open_flag=1;
}
void MyWidget::nextpage_slot(){nextpage_flag=1;}
void MyWidget::prevpage_slot(){prevpage_flag=1;}
void MyWidget::stop_slot(){stop_flag=1;}
void MyWidget::pause_slot(){pause_flag=1;}
void MyWidget::play_slot(){play_flag=1;}
void MyWidget::reseek_slot(){reseek_flag=1;}
void killer(int z)
{
    printf("quit_flag=1\n");
    quit_flag=1;
}


MyPainter* painter=0;
void PixmapButton::paintEvent(QPaintEvent* pe)
{
    QPushButton::paintEvent(pe);
    QPainter p(this);
    p.drawPixmap(2,2,m_pm);
}    

bool MyWidget::close( bool alsoDelete )
{
    killer(0);
    return QWidget::close(alsoDelete);
}
void MyWidget::paintEvent(QPaintEvent *)
{
    if(!player)
    {
	drawBackground();
	return;
    }
    if((!player->isValid()) || (player->isStopped()))
    {
    	drawBackground();
	return;
    }	
    m->updatePos();
    return;
}


void MyWidget::reseek_func()
{
    double pos=scroller->value();
    player->reseek_exact(pos);
    updatePos();
}
static long long longcount()
{
    unsigned int i;
    unsigned int j;
    __asm__ __volatile__("rdtsc\n\t":"=a"(i), "=d"(j):);
    return ((long long)j<<32)+(long long)i;
}

void drawfunc(char* data)
{
    static int counter=0;
    static long long lastcount=0;
    if (quit_flag) return;
    if(data)
    {
	long long timestamp=longcount();
	double time=(timestamp-lastcount)/550000000.;
	lastcount=timestamp;
/**
 *
 *  Duration of one frame can vary up to approx. +/- 15 ms. It should not
 * visible by naked eye. The only way to fix it is to remove usleep() with
 * variable duration in main_thread(), but it'll result in 100% CPU usage.
 * That's not what I want.
 *
 */
//	printf("Frame: %f ms\n", time*1000.);
//	printf("%d:%.2d:%2f\n", int(time/3600), int(time/60)%60, time-(int)time);
    	renderer->Draw(painter, data);
	m->drawSubtitles();
    }	
    if((counter++) % 25 == 0)
	m->updatePos();
    qApp->processEvents(10);
}
/*void posfunc(double pos)
{
    m->updatePos(pos);
}*/
void stopfunc(int)
{
    m->scroller->setValue(0);
    m->drawBackground();
}
void MyWidget::drawBackground()
{
    if(painter==0)return;
    QPixmap qpm;
//   This line can draw a default picture on background when player is stopped   //    
//    qpm.load("/d/Drafts/test3.bmp");
    painter->eraseRect(0,0,player->width(), player->height());
    painter->drawPixmap((player->width()-qpm.width())/2, (player->height()-qpm.height())/2, qpm);
}

MyWidget::MyWidget(int width, int height)
{
    renderer=0;
    painter=0;
    resize(width, height);
    setFixedSize(width, height);
    setFixedSize(width, height);
    scroller=new QScrollBar(this);
    int h=height-50;
    int w=width;

    QPixmap pm;
    bool result=pm.load(SHARE_PATH"/pause.ppm");
    b_pause=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/open.ppm");
    b_open=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/stop.ppm");
    b_stop=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/play.ppm");
    b_play=new PixmapButton(pm, "", this);
// Here we can set an icon for the application.
// Does anyone know how to draw an AVI player? :) No? Well, 
// then let's leave this for a while.
    pm.load(SHARE_PATH"/test.png");
    setIcon(pm);
    
    scroller->move(85, h+5);
    scroller->resize(w-90, 20);
    scroller->setOrientation(QScrollBar::Horizontal);

    b_open->move(5, h+5);
    b_pause->move(25, h+5);
    b_play->move(45, h+5);
    b_stop->move(65, h+5);
    b_pause->resize(20, 20);
    b_open->resize(20, 20);
    b_play->resize(20, 20);
    b_stop->resize(20, 20);
    
    connect(scroller, SIGNAL(sliderReleased()), this, SLOT(reseek_slot()));
    connect(scroller, SIGNAL(nextPage()), this, SLOT(nextpage_slot()));
    connect(scroller, SIGNAL(prevPage()), this, SLOT(prevpage_slot()));

    connect(b_pause, SIGNAL(clicked()), this, SLOT(pause_slot()));
    connect(b_open, SIGNAL(clicked()), this, SLOT(open_slot()));    
    connect(b_stop, SIGNAL(clicked()), this, SLOT(stop_slot()));    
    connect(b_play, SIGNAL(clicked()), this, SLOT(play_slot()));    

    player=CreateAviPlayer();
    player->setKillHandler(&stopfunc);
    player->setDrawCallback(&drawfunc);
}

void MyWidget::open_func()
{
    try
    {
	initPlayer(open_qs, m_zoom);
    }	
    catch(FatalError& error)
    {
	QMessageBox::information(this, 
	    QString("Error in ")+QString(error.GetModule())+QString(" module"),
	    error.GetDesc(), QMessageBox::Ok);
	error.PrintAll();
	int w=384;	
	int h=20;
	setFixedSize(w,h+50);

        scroller->move(85, h+5);
	scroller->resize(w-90, 20);
        b_open->move(5, h+5);
	b_pause->move(25, h+5);
        b_play->move(45, h+5);
        b_stop->move(65, h+5);

	repaint();
    }	
}
MyWidget::~MyWidget()
{
    endPlayer();
    if(player)delete player;
}
void MyWidget::drawSubtitles()
{
	static int nonzero=0;
	const char* cur_sub=player->GetCurrentSubtitles();
	if(cur_sub==0)return;//shouldn't happen
	char* sub=(char*)malloc(strlen(cur_sub)+1);
	strcpy(sub, cur_sub);
	char* sub_start=sub;
	static char* prev_sub=0;
	int w=player->width();
	int h=player->height();
	if(m_zoom==2)
	{
	    w/=2;
	    h/=2;
	}    
	if(w<150)w=150;
//	cout<<"Dims "<<w<<" "<<h<<endl;
        if(player->HasSubtitles())
	    h+=100;
        else
	    return;
//	cout<<"Drawing"<<endl;
	painter->setPen(QPen(QColor(255,255,255)));
	if(prev_sub)
	    if(strcmp(prev_sub, sub))
		painter->fillRect(0, h-100, w, 50, QBrush(QColor(0,0,0)));
//		painter->eraseRect(0, h-100, w, 50);
//	cout<<sub<<endl;	
	if(prev_sub)free(prev_sub);
	prev_sub=(char*)malloc(strlen(sub)+1);
	strcpy(prev_sub, sub);
	char* run=sub;
	int line=0;
	while(*run!=0)
	{
	    run=strchr(run, '|');
	    if(run)*run=0;
	    painter->drawText(w/2-3*strlen(sub), h-80+20*line, sub);
	    if(run==NULL)break;
	    line++;
	    run++;
	    sub=run;
	}
	painter->setPen(QPen(QColor(0,0,0)));
	free(sub_start);    
}
void MyWidget::updatePos()
{
    if(!player->isValid())return;
    double pos=player->GetPos();
    if(!scroller->draggingSlider())
	scroller->setValue(pos);
    char dropstring[100];
    int w=player->width();
    int h=player->height();
    if(m_zoom==2)
    {
        w/=2;
        h/=2;
    }    
    if(w<150)w=150;
    if(player->HasSubtitles())
	h+=100;
    else
        h+=50;
    sprintf(dropstring, "Drop: %.2f %%", player->GetDrop());
    painter->eraseRect(5, h-35, w, 75);
    painter->drawText(5, h-5, dropstring);
    char timing[50];
    if(w>90)
    {
	double len=player->GetVideoLength();
        double stream_time=pos;
        if(stream_time>=3600)
    	    sprintf(timing, "%d:%02d:%02d/",
		int(stream_time/3600), int(stream_time/60)%60,
    		int(stream_time)%60);
	else
	    sprintf(timing, "%02d:%02d/",
		int(stream_time/60)%60,
		int(stream_time)%60);
	if(len>=3600)
	    sprintf(timing+strlen(timing), "%d:%02d:%02d",
		int(len/3600), int(len/60)%60,
		int(len)%60);
	else
	    sprintf(timing+strlen(timing), "%02d:%02d",
		int(len/60)%60,
		int(len)%60);
	painter->drawText(w-90, h-5, timing);
    }
}    
void MyWidget::endPlayer()
{
    if(player)
	player->endPlayer();
    if(renderer)
	delete renderer;
    renderer=0;
    if(painter)
	delete painter;
    painter=0;
}
#define __MODULE__ "AVI player widget"
int MyWidget::initPlayer(const char* filename, int zoom, const char* subname=NULL)
{
    try
    {
        m_zoom=zoom;
        if(painter==0)
	    painter=new MyPainter(this);
	if(player->isValid())
	    player->endPlayer();    
	int success=player->initPlayer(filename, GetPhysicalDepth(this), subname);

        int w=player->width();
	int h=player->height();
	renderer=CreateRenderer();
        int result;
	if(zoom==2)
        {
    	    result=renderer->Create(this, w, h, 2, (w/2<150)?75-w/4:0);
	    w/=2;
	    h/=2;
        }
	else result=renderer->Create(this, w, h, 1, (w<150)?75-w/2:0);

        if(w<150)w=150;
	if(player->HasSubtitles())
	    h+=100;
	else
	    h+=50;
	setFixedSize(w,h);
        move(100,100);	
	setCaption(filename);
        //
	//
        //	Scroll bar
	//
        //
#if(QT_VERSION<210)
        scroller->setRange(0, player->GetVideoLength());
#else
	scroller->setMinValue(0);
	scroller->setMaxValue(player->GetVideoLength());
#endif
          
	scroller->move(85, h-45);
        scroller->resize(w-90, 20);
	b_open->move(5, h-45);
        b_pause->move(25, h-45);
        b_play->move(45, h-45);
        b_stop->move(65, h-45);
        
	player->start();
        cout<<"Player started"<<endl;
        return 0;
    }
    catch(FatalError& error)
    {
	endPlayer();
//	error.PrintAll();
	throw;
    }	
    catch(...)
    {
	cerr<<"Unknown exception"<<endl;
    }	
}
void MyWidget::keyPressEvent(QKeyEvent * event)
{
    // well-known x11amp key events: 'x' stop, 'c' pause, 'v' play.
    switch(event->ascii())
    {
	case 'x':
	case 'X':
	    stop_slot();
	    break;
	case 'c':
	case 'C':
	    pause_slot();
	    break;
	case 'v':
	case 'V':
	    play_slot();
	    break;
    }	            
}
/*
void MyWidget::resizeEvent(QResizeEvent* ev)
{
    printf("Resize()\n");
    const QSize& s=ev->size();
    int picw=s.width();
    int pich=s.height();
    if(player==0)
    {
	printf("player=0\n");
	goto fail;
    }	
    if(renderer==0)
    {
	printf("renderer=0\n");
	goto fail;
    }	
    if(player->isValid()==0)goto fail;
    if(player->HasSubtitles())
	pich-=100;
    else
	pich-=50;
    renderer->Resize(picw, pich);
fail:
;
    QWidget::resizeEvent(ev);
}	
*/	
#include "mywidget.moc"
