#include <qwidget.h>
#include <qscrollbar.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <aviplay.h>
#include <except.h>
#include <stdio.h>
class PixmapButton: public QPushButton
{
    QPixmap m_pm;
public:    
    PixmapButton(QPixmap& pm, const char* name, QWidget* parent):QPushButton(name,parent), m_pm(pm){}
protected:    
    void paintEvent(QPaintEvent *qp);
};

class MyWidget :public QWidget
{
	Q_OBJECT
friend void posfunc(double);
friend void stopfunc(int);
protected:
	void paintEvent(QPaintEvent *);
	void keyPressEvent(QKeyEvent *);
//	void resizeEvent(QResizeEvent *);
	IAviPlayer* player;
	int m_zoom;
public:
	MyWidget(int, int);
	~MyWidget();
	virtual bool close( bool alsoDelete );
	int initPlayer(const char* filename, int zoom, const char* subname=NULL);
	void endPlayer();
	void updatePos();
	void drawSubtitles();
	int isValid(){return player->isValid();}
	int isStopped(){return player->isStopped();}
	int isPlaying(){return player->isPlaying();}
	void drawBackground();
public slots:
	void nextpage_slot();
	void nextpage_func()
	{
	    if(player->isValid())
	    {
		if(player->page_up()==0)
		    updatePos();
	    }	
        }
	void prevpage_slot();
	void prevpage_func()
	{
	    if(player->isValid())
		if(player->page_down()==0)
		    updatePos();
	}
	void reseek_slot();
	void reseek_func();
	void pause_slot();
	void pause_func()
	{
	    if(player->isValid())
	    {
		if(player->isPaused())
		    player->pause(false);
    		else
		    player->pause(true);
	    }	    
	}
	void open_slot();
	void open_func();
	void stop_slot();	
	void stop_func()
	{
	    if(player->isValid())
	    {
		player->stop();
		scroller->setValue(0);
		drawBackground();
	    }	
	}    
	void play_slot();
	void play_func()
	{
	    if(player->isValid())
	    {
		if(!player->isPlaying())
		    player->start();
		else
		    player->pause(false);
	    }
	}    	
protected:
	QScrollBar* scroller;
	PixmapButton *b_play;
	PixmapButton *b_open;
	PixmapButton *b_pause;
	PixmapButton *b_stop;
};
