/*
    Fast and ugly assembly image stretcher
    Copyright (C) 1999 Tomasz Cejner

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    WARNING
    =======
    
    This piece of code is based on self-modifying code. That way of
    programming is not recommended. 
    In the other words: don't try this at home :)
*/

#ifndef _STRETCH_H
#define _STRETCH_H


/* setup scaling routine. must be called before AS_stretchBlit 
   Returns 0 on success, nonzero if bit depth is invalid (not 16 nor 32),
   Downscaling (to lower resolution) is not implemented too.    
*/
#ifdef __cplusplus
extern "C" {
#endif
int AS_setupStretcher (int srcw, int srch, int destw, int desth, int bpp);

extern void AS_stretchBlit (void *scr, void *dest);


/* internal variables, do not tamper */

int AS_stretcher_code[4096];
extern int AS_src_w, AS_dest_h, AS_h_factor;
#ifdef __cplusplus
}
#endif
#endif
