/*

    Fast and ugly assembly image stretcher.
    Copyright (C) 1999 Tomasz Cejner

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Tomasz Cejner
    heretyk@cyber.cs.net.pl
*/

.section .data

.globl AS_stretchBlit
.globl AS_stretcher_code

.globl AS_src_w
.data
	.align 4
	.type	 AS_src_w,@object
	.size	 AS_src_w,4
AS_src_w:
	.long 0

.globl AS_dest_h
.data
	.align 4
	.type	 AS_dest_h,@object
	.size	 AS_dest_h,4
AS_dest_h:
	.long 0
.globl AS_h_factor
.data
	.align 4
	.type	 AS_h_factor,@object
	.size	 AS_h_factor,4
AS_h_factor:
	.long 0



/*
  AS_stretchBlit
----------------------------------
  (ebp+8+...)
   0: Uint8* src_pixels
   4: Uint8* dest_pixels
   8: int src_w
  12: int dest_h
  16: int factor

  (ebp+8+...)
   0: Uint8* src_pixels
   4: Uint8* dest_pixels
*/
.text
	.align 8
	.type	 AS_stretchBlit,@function
AS_stretchBlit:
        pushl %ebp
        movl %esp, %ebp
        pusha
	        
        cld
        movl 8(%ebp), %esi    //	      ; ESI = source data
        movl 12(%ebp), %edi   //        ; EDI = dest. data
	movl AS_src_w, %ebx
        xorl %edx,%edx    
        movl AS_dest_h, %ecx  //         ; Destination height
	.align 8
.loop:
        call AS_stretcher_code
        
        addl AS_h_factor, %edx
        
        cmp $0x10000, %edx
        jb .skip              
        subl $0x10000, %edx
	decl %ecx
	jnz .loop
	jmp .finish
	.align 4
.skip:        
        subl %ebx, %esi        //           ; draw source line again    
        decl %ecx
        jnz .loop  
.finish:        
        popa
        popl %ebp
        ret

	.comm	AS_stretcher_code,4096,32












