/**************************************************************************

	Example of IAviWriteFile & IAviVideoWriteStream interface usage.
	Copyright 2000 Eugene Smith (divx@euro.ru)
	Last modified: 27.07.2000
	
**************************************************************************/


#include <stdio.h>
#include <string.h>
#include <videoencoder.h>
#include <avifile.h>
#include <aviplay.h>
#include <except.h>
#define __MODULE__ "avitest"
int main(int argc, char** argv)
{
    int fccHandler=fccIV41;
    IAviWriteFile* file;    
    FILE* f1;
    if(GetAvifileVersion()!=AVIFILE_VERSION)
    {
	cout<<"This binary was compiled for Avifile ver. "<<AVIFILE_VERSION<<", but the library is ver. "<<GetAvifileVersion()<<". Aborting."<<endl;
	return 0;
    }	
    if(argc!=2)
    {
	printf("Usage: %s <output file>\n", argv[0]);
	return 0;
    }	
    try
    {
	file=CreateIAviWriteFile(argv[1]);

	f1=fopen("./uncompr.bmp", "rb");
	if(f1==0)throw FATAL("Can't open file ./uncompr.bmp");
        fseek(f1, 14, SEEK_SET);//BITMAPFILEHEADER
	BITMAPINFOHEADER bh;
        fread(&bh, 0x28, 1, f1);
	IAviVideoWriteStream* stream=file->AddVideoStream(fccHandler, &bh);

        char pic[384*288*3];
	fread(pic, 384*288*3, 1, f1);
    
        VideoEncoder::SetExtendedAttr(fccDIV3, "BitRate", 4500);//before we initialize decoder

	stream->SetHeader(40000);//mks/frame
	stream->Start();
        for(int i=0; i<16; i++)
	{
	    stream->AddFrame(pic);
    	    memset(pic+384*i*2*3, 0, 384*2*3);
	    memset(pic+384*(143-i)*2*3, 0, 384*2*3);
	    if(i%10==0)
		printf("%d frames written\n", i);
	}
        stream->Stop();
	delete file;//here all headers are actually written
        fclose(f1);
	return 0;
    }
    catch(FatalError& error)
    {
	error.Print();
	if(file)delete file;
	if(f1)fclose(f1);
    }
    catch(...)
    {
	cout<<"ERROR: Caught unknown exception!"<<endl;
    }		
    return 0;
}    
    