#include <stdio.h>
#include <videoencoder.h>
#include <except.h>
#define __MODULE__ "plustest"
int main()
{
    VideoEncoder enc;
    FILE* f1=0, *f2=0;
    char* compressed=0;
    try
    {
        f1=fopen("./uncompr.bmp", "rb");
	if(f1==0)
	    throw FATAL("This program expects to find 384x288x24 file ./uncompr.bmp");	            
	fseek(f1, 14, SEEK_SET);
        char bh[0x28];
	fread(bh, 0x28, 1, f1);
        char pic[384*288*3];
    	fread(pic, 384*288*3, 1, f1);
        enc.Init(mmioFOURCC('m', 'j', 'p', 'g'), bh);
	enc.SetKeyFrame(10);
        int size=enc.QueryOutputSize();
	if(size<=0)
	    throw FATAL("QueryOutputSize() failed");
        else 
    	    printf("Driver reported %d as a maximum output size\n", size);
	compressed=new char[size];
        enc.Start();
	int keyf;
        for(int i=0; i<30; i++)
	{
    	    if(enc.EncodeFrame(pic, compressed, &keyf, &size)!=0)
	    {
		printf("EncodeFrame() failed\n");
            }
	    else printf("Frame %d encoded as %d ( %s ) into %d bytes\n", i, keyf, keyf&16?"Key frame":"Delta frame", size);
        }
	enc.Stop();
        f2=fopen("./compr.qw", "wb");
	fwrite(compressed, size, 1, f2);
    }
    catch(FatalError& error)
    {
	error.PrintAll();
    }	
    if(f1)fclose(f1);
    if(f2)fclose(f2);
    if(compressed)delete compressed;
    ICDoSomething();
    return 0;
}
